﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Infragistics.Controls.Schedules;


namespace WpfGantChartApp.Models
{
    class NativeProjectViewModel : ObservableModel
    {
        #region Constructor
        public NativeProjectViewModel()
        {
            this._project = new Project(); 
            ProjectTask root = new ProjectTask { TaskName = "Root Task", IsManual = false, Duration = new TimeSpan(3, 0, 0, 0) };

            Project.RootTask.Tasks.Add(root);
        }
        #endregion //Constructor

        #region SelectedTask
        private ProjectTask _selectedTask;
        public ProjectTask SelectedTask
        {
            get
            {
                return _selectedTask;
            }
            set
            {
                if (value != null)
                {
                    _selectedTask = value;
                }

                NotifyPropertyChanged("SelectedTask");
            }
        }
        #endregion SelectedTask

        #region Project
        private Project _project;
        public Project Project
        {
            get
            {
                return this._project;
            }
            set
            {
                if (this._project != value)
                {
                    this._project = value;
                    this.NotifyPropertyChanged("Project");
                }
            }
        }
        #endregion //Project

    }
}
