﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Infragistics.Controls.Schedules;

namespace WpfGantChartApp.Models
{
    class TaskModel : ObservableModel
    {
        #region ConstraintType
        private ProjectTaskConstraintType _constraintType;
        public ProjectTaskConstraintType ConstraintType
        {
            get
            {
                return _constraintType;
            }
            set
            {
                if (_constraintType != value)
                {
                    _constraintType = value;
                    this.NotifyPropertyChanged("ConstraintType");
                }
            }
        }
        #endregion ConstraintType

        #region ConstraintDate
        private DateTime _constraintDate;
        public DateTime ConstraintDate
        {
            get
            {
                return _constraintDate;
            }
            set
            {
                if (_constraintDate != value)
                {
                    _constraintDate = value;
                    this.NotifyPropertyChanged("ConstraintDate");
                }
            }
        }
        #endregion ConstraintDate

        #region DeadlineDate
        private DateTime? _deadlineDate;
        public DateTime? DeadlineDate
        {
            get
            {
                return _deadlineDate;
            }
            set
            {
                if (_deadlineDate != value)
                {
                    _deadlineDate = value;
                    this.NotifyPropertyChanged("DeadlineDate");
                }
            }
        }
        #endregion //DeadlineDate

        #region DurationFormat
        private ProjectDurationFormat _durationFormat;
        public ProjectDurationFormat DurationFormat
        {
            get
            {
                return _durationFormat;
            }
            set
            {
                if (_durationFormat != value)
                {
                    _durationFormat = value;
                    this.NotifyPropertyChanged("DurationFormat");
                }
            }
        }
        #endregion DurationFormat

        #region Duration
        private TimeSpan _duration;
        public TimeSpan Duration
        {
            get
            {
                return _duration;
            }
            set
            {
                if (_duration != value)
                {
                    _duration = value;
                    this.NotifyPropertyChanged("Duration");
                }
            }
        }
        #endregion Duration

        #region IsMilestone
        private bool _isMilestone = false;
        public bool IsMilestone
        {
            get
            {
                return _isMilestone;
            }
            set
            {
                if (_isMilestone != value)
                {
                    _isMilestone = value;
                    this.NotifyPropertyChanged("IsMilestone");
                }
            }
        }
        #endregion IsMilestone

        #region IsInProgress
        private bool _isInProgress = true;
        public bool IsInProgress
        {
            get
            {
                return _isInProgress;
            }
            set
            {
                if (_isInProgress != value)
                {
                    _isInProgress = value;
                    this.NotifyPropertyChanged("IsInProgress");
                }
            }
        }
        #endregion IsInProgress

        #region IsUndetermined
        private bool _isUndetermined = false;
        public bool IsUndetermined
        {
            get
            {
                return _isUndetermined;
            }
            set
            {
                if (_isUndetermined != value)
                {
                    _isUndetermined = value;
                    this.NotifyPropertyChanged("IsUndetermined");
                }
            }
        }
        #endregion //IsUndetermined

        #region Predecessors
        private string _predecesors;
        public string Predecessors
        {
            get { return _predecesors; }
            set
            {
                if (value != _predecesors)
                {
                    _predecesors = value;
                    this.NotifyPropertyChanged("Predecessors");
                }
            }
        }
        #endregion //Predecessors

        #region Successors
        private string _successors;
        public string Successors
        {
            get { return _successors; }
            set
            {
                if (value != _successors)
                {
                    _successors = value;
                    this.NotifyPropertyChanged("Successors");
                }
            }
        }
        #endregion //Successors

        #region Start
        private DateTime _start;
        public DateTime Start
        {
            get
            {
                return _start;
            }
            set
            {
                if (_start != value)
                {
                    _start = value;
                    this.NotifyPropertyChanged("Start");
                }
            }
        }
        #endregion Start


        #region TaskID
        private string _taskId;
        public string TaskID
        {
            get
            {
                return _taskId;
            }
            set
            {
                if (_taskId != value)
                {
                    _taskId = value;
                    this.NotifyPropertyChanged("TaskID");
                }
            }
        }
        #endregion TaskID

        #region Tasks
        private string _tasks;
        public string Tasks
        {
            get
            {
                return _tasks;
            }
            set
            {
                if (_tasks != value)
                {
                    _tasks = value;
                    this.NotifyPropertyChanged("Tasks");
                }
            }
        }
        #endregion Tasks

        #region TaskName
        private string _name;
        public string TaskName
        {
            get
            {
                return _name;
            }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    this.NotifyPropertyChanged("TaskName");
                }
            }
        }
        #endregion TaskName

        #region ResourceName
        private string _resourceName;
        public string ResourceName
        {
            get
            {
                return _resourceName;
            }
            set
            {
                if (_resourceName != value)
                {
                    _resourceName = value;
                    this.NotifyPropertyChanged("ResourceName");
                }
            }
        }
        #endregion ResourceName

    }
}
